import 'dart:async';

import 'package:flutter/widgets.dart';

abstract class AsyncAction<T extends Intent> extends Action<T> {
  bool running = false;
  @override
  Object? invoke(covariant T intent) async {
    if (!running) {
      // print('1-ScreenshotAction ${intent}');
      running = true;
      try {
        await invokeAsync(intent);
      } finally {
        running = false;
      }
    }
  }

  FutureOr<Object?> invokeAsync(covariant T intent);
}
