import 'package:flutter/material.dart';
import 'package:flutter/services.dart';

import 'key_listner_action.dart';
import 'key_listner_intent.dart';

class KeyListner extends StatelessWidget {
  const KeyListner({
    Key? key,
    required this.child,
    required this.keyDownAction,
    required this.keyUpAction,
    required this.keyboardKey,
  }) : super(key: key);

  final Widget child;
  final Action? keyDownAction;
  final Action? keyUpAction;
  final LogicalKeyboardKey keyboardKey;

  @override
  Widget build(BuildContext context) {
    final k = KeyListnerAction(keyDownAction, keyUpAction);

    return Focus(
      autofocus: true,
      child: KeyboardListener(
        onKeyEvent: (value) async {
          if (keyboardKey != value.logicalKey) {
            return;
          } else if (value is KeyRepeatEvent) {
            return;
          }
          k.invoke(KeyListnerIntent(value, value.logicalKey));
        },
        focusNode: FocusNode(),
        child: child,
      ),
    );
  }
}
