import 'package:flutter/services.dart';
import 'package:flutter/widgets.dart';

import 'key_listner_intent.dart';

class KeyListnerAction extends Action {
  final Action? keyDownAction;
  final Action? keyUpAction;

  KeyListnerAction(this.keyDownAction, this.keyUpAction);

  @override
  Object? invoke(covariant KeyListnerIntent intent) {
    if (intent.keyEvent is KeyUpEvent) {
      keyUpAction?.invoke(intent);
    } else {
      keyDownAction?.invoke(intent);
    }
  }
}
